/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * Mathesar API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This file is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the file manually.
 */

import * as url from "url";
import * as isomorphicFetch from "isomorphic-fetch";
import { Configuration } from "./configuration";

const BASE_PATH = "/".replace(/\/+$/, "");

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};

/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}

/**
 *
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}

/**
 *
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
    protected configuration: Configuration;

    constructor(configuration?: Configuration, protected basePath: string = BASE_PATH, protected fetch: FetchAPI = isomorphicFetch) {
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
};

/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
    name: "RequiredError"
    constructor(public field: string, msg?: string) {
        super(msg);
    }
}

/**
 * * `FILE` - File * `PASTE` - Paste * `URL` - Url
 * @export
 * @enum {string}
 */
export enum CreatedFromEnum {
    FILE = <any> 'FILE',
    PASTE = <any> 'PASTE',
    URL = <any> 'URL'
}
/**
 * 
 * @export
 * @interface DataFile
 */
export interface DataFile {
    /**
     * 
     * @type {number}
     * @memberof DataFile
     */
    id: number;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    file?: string;
    /**
     * 
     * @type {number}
     * @memberof DataFile
     */
    tableImportedTo: number;
    /**
     * 
     * @type {number}
     * @memberof DataFile
     */
    user: number;
    /**
     * 
     * @type {boolean}
     * @memberof DataFile
     */
    header?: boolean;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    delimiter?: string;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    escapechar?: string;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    quotechar?: string;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    paste?: string;
    /**
     * 
     * @type {string}
     * @memberof DataFile
     */
    url?: string;
    /**
     * 
     * @type {CreatedFromEnum}
     * @memberof DataFile
     */
    createdFrom: CreatedFromEnum;
}
/**
 * 
 * @export
 * @interface PaginatedDataFileList
 */
export interface PaginatedDataFileList {
    /**
     * 
     * @type {number}
     * @memberof PaginatedDataFileList
     */
    count?: number;
    /**
     * 
     * @type {string}
     * @memberof PaginatedDataFileList
     */
    next?: string;
    /**
     * 
     * @type {string}
     * @memberof PaginatedDataFileList
     */
    previous?: string;
    /**
     * 
     * @type {Array<DataFile>}
     * @memberof PaginatedDataFileList
     */
    results?: Array<DataFile>;
}
/**
 * 
 * @export
 * @interface PatchedDataFile
 */
export interface PatchedDataFile {
    /**
     * 
     * @type {number}
     * @memberof PatchedDataFile
     */
    id?: number;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    file?: string;
    /**
     * 
     * @type {number}
     * @memberof PatchedDataFile
     */
    tableImportedTo?: number;
    /**
     * 
     * @type {number}
     * @memberof PatchedDataFile
     */
    user?: number;
    /**
     * 
     * @type {boolean}
     * @memberof PatchedDataFile
     */
    header?: boolean;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    delimiter?: string;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    escapechar?: string;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    quotechar?: string;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    paste?: string;
    /**
     * 
     * @type {string}
     * @memberof PatchedDataFile
     */
    url?: string;
    /**
     * 
     * @type {CreatedFromEnum}
     * @memberof PatchedDataFile
     */
    createdFrom?: CreatedFromEnum;
}
/**
 * ApiApi - fetch parameter creator
 * @export
 */
export const ApiApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {DataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesCreate(body?: DataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options: any = {}): FetchArgs {
            const localVarPath = `/api/db/v0/data_files/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new url.URLSearchParams();

            // authentication cookieAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("sessionid")
					: configuration.apiKey;
                localVarQueryParameter["sessionid"] = localVarApiKeyValue;
            }

            // authentication tokenAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("Authorization")
					: configuration.apiKey;
                localVarHeaderParameter["Authorization"] = localVarApiKeyValue;
            }

            if (id !== undefined) {
                localVarFormParams.set('id', id as any);
            }

            if (file !== undefined) {
                localVarFormParams.set('file', file as any);
            }

            if (tableImportedTo !== undefined) {
                localVarFormParams.set('table_imported_to', tableImportedTo as any);
            }

            if (user !== undefined) {
                localVarFormParams.set('user', user as any);
            }

            if (header !== undefined) {
                localVarFormParams.set('header', header as any);
            }

            if (delimiter !== undefined) {
                localVarFormParams.set('delimiter', delimiter as any);
            }

            if (escapechar !== undefined) {
                localVarFormParams.set('escapechar', escapechar as any);
            }

            if (quotechar !== undefined) {
                localVarFormParams.set('quotechar', quotechar as any);
            }

            if (paste !== undefined) {
                localVarFormParams.set('paste', paste as any);
            }

            if (url !== undefined) {
                localVarFormParams.set('url', url as any);
            }

            if (createdFrom !== undefined) {
                localVarFormParams.set('created_from', createdFrom as any);
            }

            if (id !== undefined) {
                localVarFormParams.set('id', id as any);
            }

            if (file !== undefined) {
                localVarFormParams.set('file', file as any);
            }

            if (tableImportedTo !== undefined) {
                localVarFormParams.set('table_imported_to', tableImportedTo as any);
            }

            if (user !== undefined) {
                localVarFormParams.set('user', user as any);
            }

            if (header !== undefined) {
                localVarFormParams.set('header', header as any);
            }

            if (delimiter !== undefined) {
                localVarFormParams.set('delimiter', delimiter as any);
            }

            if (escapechar !== undefined) {
                localVarFormParams.set('escapechar', escapechar as any);
            }

            if (quotechar !== undefined) {
                localVarFormParams.set('quotechar', quotechar as any);
            }

            if (paste !== undefined) {
                localVarFormParams.set('paste', paste as any);
            }

            if (url !== undefined) {
                localVarFormParams.set('url', url as any);
            }

            if (createdFrom !== undefined) {
                localVarFormParams.set('created_from', createdFrom as any);
            }

            localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            localVarRequestOptions.body = localVarFormParams.toString();
            const needsSerialization = (<any>"DataFile" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {Array<string>} [database] Multiple values may be separated by commas.
         * @param {number} [limit] Number of results to return per page.
         * @param {Array<string>} [name] Multiple values may be separated by commas.
         * @param {number} [offset] The initial index from which to return the results.
         * @param {Array<string>} [sortBy] Sort By  * &#x60;id&#x60; - Id * &#x60;-id&#x60; - Id (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesList(database?: Array<string>, limit?: number, name?: Array<string>, offset?: number, sortBy?: Array<string>, options: any = {}): FetchArgs {
            const localVarPath = `/api/db/v0/data_files/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication cookieAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("sessionid")
					: configuration.apiKey;
                localVarQueryParameter["sessionid"] = localVarApiKeyValue;
            }

            // authentication tokenAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("Authorization")
					: configuration.apiKey;
                localVarHeaderParameter["Authorization"] = localVarApiKeyValue;
            }

            if (database) {
                localVarQueryParameter['database'] = database.join(COLLECTION_FORMATS["csv"]);
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (name) {
                localVarQueryParameter['name'] = name.join(COLLECTION_FORMATS["csv"]);
            }

            if (offset !== undefined) {
                localVarQueryParameter['offset'] = offset;
            }

            if (sortBy) {
                localVarQueryParameter['sort_by'] = sortBy.join(COLLECTION_FORMATS["csv"]);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {PatchedDataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesPartialUpdate(id: number, body?: PatchedDataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling apiDbV0DataFilesPartialUpdate.');
            }
            const localVarPath = `/api/db/v0/data_files/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'PATCH' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new url.URLSearchParams();

            // authentication cookieAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("sessionid")
					: configuration.apiKey;
                localVarQueryParameter["sessionid"] = localVarApiKeyValue;
            }

            // authentication tokenAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("Authorization")
					: configuration.apiKey;
                localVarHeaderParameter["Authorization"] = localVarApiKeyValue;
            }

            if (id !== undefined) {
                localVarFormParams.set('id', id as any);
            }

            if (file !== undefined) {
                localVarFormParams.set('file', file as any);
            }

            if (tableImportedTo !== undefined) {
                localVarFormParams.set('table_imported_to', tableImportedTo as any);
            }

            if (user !== undefined) {
                localVarFormParams.set('user', user as any);
            }

            if (header !== undefined) {
                localVarFormParams.set('header', header as any);
            }

            if (delimiter !== undefined) {
                localVarFormParams.set('delimiter', delimiter as any);
            }

            if (escapechar !== undefined) {
                localVarFormParams.set('escapechar', escapechar as any);
            }

            if (quotechar !== undefined) {
                localVarFormParams.set('quotechar', quotechar as any);
            }

            if (paste !== undefined) {
                localVarFormParams.set('paste', paste as any);
            }

            if (url !== undefined) {
                localVarFormParams.set('url', url as any);
            }

            if (createdFrom !== undefined) {
                localVarFormParams.set('created_from', createdFrom as any);
            }

            if (id !== undefined) {
                localVarFormParams.set('id', id as any);
            }

            if (file !== undefined) {
                localVarFormParams.set('file', file as any);
            }

            if (tableImportedTo !== undefined) {
                localVarFormParams.set('table_imported_to', tableImportedTo as any);
            }

            if (user !== undefined) {
                localVarFormParams.set('user', user as any);
            }

            if (header !== undefined) {
                localVarFormParams.set('header', header as any);
            }

            if (delimiter !== undefined) {
                localVarFormParams.set('delimiter', delimiter as any);
            }

            if (escapechar !== undefined) {
                localVarFormParams.set('escapechar', escapechar as any);
            }

            if (quotechar !== undefined) {
                localVarFormParams.set('quotechar', quotechar as any);
            }

            if (paste !== undefined) {
                localVarFormParams.set('paste', paste as any);
            }

            if (url !== undefined) {
                localVarFormParams.set('url', url as any);
            }

            if (createdFrom !== undefined) {
                localVarFormParams.set('created_from', createdFrom as any);
            }

            localVarHeaderParameter['Content-Type'] = 'application/x-www-form-urlencoded';

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            localVarRequestOptions.body = localVarFormParams.toString();
            const needsSerialization = (<any>"PatchedDataFile" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(body || {}) : (body || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesRetrieve(id: number, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling apiDbV0DataFilesRetrieve.');
            }
            const localVarPath = `/api/db/v0/data_files/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication cookieAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("sessionid")
					: configuration.apiKey;
                localVarQueryParameter["sessionid"] = localVarApiKeyValue;
            }

            // authentication tokenAuth required
            if (configuration && configuration.apiKey) {
                const localVarApiKeyValue = typeof configuration.apiKey === 'function'
					? configuration.apiKey("Authorization")
					: configuration.apiKey;
                localVarHeaderParameter["Authorization"] = localVarApiKeyValue;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ApiApi - functional programming interface
 * @export
 */
export const ApiApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {DataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesCreate(body?: DataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<DataFile> {
            const localVarFetchArgs = ApiApiFetchParamCreator(configuration).apiDbV0DataFilesCreate(body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {Array<string>} [database] Multiple values may be separated by commas.
         * @param {number} [limit] Number of results to return per page.
         * @param {Array<string>} [name] Multiple values may be separated by commas.
         * @param {number} [offset] The initial index from which to return the results.
         * @param {Array<string>} [sortBy] Sort By  * &#x60;id&#x60; - Id * &#x60;-id&#x60; - Id (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesList(database?: Array<string>, limit?: number, name?: Array<string>, offset?: number, sortBy?: Array<string>, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<PaginatedDataFileList> {
            const localVarFetchArgs = ApiApiFetchParamCreator(configuration).apiDbV0DataFilesList(database, limit, name, offset, sortBy, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {PatchedDataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesPartialUpdate(id: number, body?: PatchedDataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<DataFile> {
            const localVarFetchArgs = ApiApiFetchParamCreator(configuration).apiDbV0DataFilesPartialUpdate(id, body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesRetrieve(id: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<DataFile> {
            const localVarFetchArgs = ApiApiFetchParamCreator(configuration).apiDbV0DataFilesRetrieve(id, options);
            return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * ApiApi - factory interface
 * @export
 */
export const ApiApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {DataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesCreate(body?: DataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any) {
            return ApiApiFp(configuration).apiDbV0DataFilesCreate(body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options)(fetch, basePath);
        },
        /**
         * 
         * @param {Array<string>} [database] Multiple values may be separated by commas.
         * @param {number} [limit] Number of results to return per page.
         * @param {Array<string>} [name] Multiple values may be separated by commas.
         * @param {number} [offset] The initial index from which to return the results.
         * @param {Array<string>} [sortBy] Sort By  * &#x60;id&#x60; - Id * &#x60;-id&#x60; - Id (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesList(database?: Array<string>, limit?: number, name?: Array<string>, offset?: number, sortBy?: Array<string>, options?: any) {
            return ApiApiFp(configuration).apiDbV0DataFilesList(database, limit, name, offset, sortBy, options)(fetch, basePath);
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {PatchedDataFile} [body] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {number} [id] 
         * @param {string} [file] 
         * @param {number} [tableImportedTo] 
         * @param {number} [user] 
         * @param {boolean} [header] 
         * @param {string} [delimiter] 
         * @param {string} [escapechar] 
         * @param {string} [quotechar] 
         * @param {string} [paste] 
         * @param {string} [url] 
         * @param {CreatedFromEnum} [createdFrom] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesPartialUpdate(id: number, body?: PatchedDataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any) {
            return ApiApiFp(configuration).apiDbV0DataFilesPartialUpdate(id, body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options)(fetch, basePath);
        },
        /**
         * 
         * @param {number} id A unique integer value identifying this data file.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiDbV0DataFilesRetrieve(id: number, options?: any) {
            return ApiApiFp(configuration).apiDbV0DataFilesRetrieve(id, options)(fetch, basePath);
        },
    };
};

/**
 * ApiApi - object-oriented interface
 * @export
 * @class ApiApi
 * @extends {BaseAPI}
 */
export class ApiApi extends BaseAPI {
    /**
     * 
     * @param {DataFile} [body] 
     * @param {number} [id] 
     * @param {string} [file] 
     * @param {number} [tableImportedTo] 
     * @param {number} [user] 
     * @param {boolean} [header] 
     * @param {string} [delimiter] 
     * @param {string} [escapechar] 
     * @param {string} [quotechar] 
     * @param {string} [paste] 
     * @param {string} [url] 
     * @param {CreatedFromEnum} [createdFrom] 
     * @param {number} [id] 
     * @param {string} [file] 
     * @param {number} [tableImportedTo] 
     * @param {number} [user] 
     * @param {boolean} [header] 
     * @param {string} [delimiter] 
     * @param {string} [escapechar] 
     * @param {string} [quotechar] 
     * @param {string} [paste] 
     * @param {string} [url] 
     * @param {CreatedFromEnum} [createdFrom] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApiApi
     */
    public apiDbV0DataFilesCreate(body?: DataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any) {
        return ApiApiFp(this.configuration).apiDbV0DataFilesCreate(body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {Array<string>} [database] Multiple values may be separated by commas.
     * @param {number} [limit] Number of results to return per page.
     * @param {Array<string>} [name] Multiple values may be separated by commas.
     * @param {number} [offset] The initial index from which to return the results.
     * @param {Array<string>} [sortBy] Sort By  * &#x60;id&#x60; - Id * &#x60;-id&#x60; - Id (descending) * &#x60;name&#x60; - Name * &#x60;-name&#x60; - Name (descending)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApiApi
     */
    public apiDbV0DataFilesList(database?: Array<string>, limit?: number, name?: Array<string>, offset?: number, sortBy?: Array<string>, options?: any) {
        return ApiApiFp(this.configuration).apiDbV0DataFilesList(database, limit, name, offset, sortBy, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {number} id A unique integer value identifying this data file.
     * @param {PatchedDataFile} [body] 
     * @param {number} [id] 
     * @param {string} [file] 
     * @param {number} [tableImportedTo] 
     * @param {number} [user] 
     * @param {boolean} [header] 
     * @param {string} [delimiter] 
     * @param {string} [escapechar] 
     * @param {string} [quotechar] 
     * @param {string} [paste] 
     * @param {string} [url] 
     * @param {CreatedFromEnum} [createdFrom] 
     * @param {number} [id] 
     * @param {string} [file] 
     * @param {number} [tableImportedTo] 
     * @param {number} [user] 
     * @param {boolean} [header] 
     * @param {string} [delimiter] 
     * @param {string} [escapechar] 
     * @param {string} [quotechar] 
     * @param {string} [paste] 
     * @param {string} [url] 
     * @param {CreatedFromEnum} [createdFrom] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApiApi
     */
    public apiDbV0DataFilesPartialUpdate(id: number, body?: PatchedDataFile, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, id?: number, file?: string, tableImportedTo?: number, user?: number, header?: boolean, delimiter?: string, escapechar?: string, quotechar?: string, paste?: string, url?: string, createdFrom?: CreatedFromEnum, options?: any) {
        return ApiApiFp(this.configuration).apiDbV0DataFilesPartialUpdate(id, body, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, id, file, tableImportedTo, user, header, delimiter, escapechar, quotechar, paste, url, createdFrom, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {number} id A unique integer value identifying this data file.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ApiApi
     */
    public apiDbV0DataFilesRetrieve(id: number, options?: any) {
        return ApiApiFp(this.configuration).apiDbV0DataFilesRetrieve(id, options)(this.fetch, this.basePath);
    }

}
